/*
 * globals.c
 *
 * all global data
 *
 * started 2/24/94 by tjl
 */

#include <hb.h>

s_color old_spectral_values[] = 
{ { { 238, 138, 238 }, USER_COLORS/16   }, /* violet (V) */
  { { 148,   0, 211 }, 2*USER_COLORS/16 }, /* dark violet (I)  */
  { { 25 ,  25, 112 }, 3*USER_COLORS/16 }, /* midnight blue (B) */
{ {   0,   0, 255 }, USER_COLORS/16 },   /* blue  (still B) */
{ {   0, 255,   0 }, 3*USER_COLORS/16 }, /* green (G) */
{ { 124, 252,   0 }, 2*USER_COLORS/16 }, /* lawn green (still g) */
{ { 255, 255,   0 }, USER_COLORS/16   }, /* yellow (Y) */
{ { 255, 165,   0 }, 3*USER_COLORS/16 }, /* orange (O) */
{ { 255,   0,   0 }, -1 } }; /* red */

s_color tested_spectral_values[] =  /* spectral, but not as good as below */
{ { {   0,   0, 255 }, USER_COLORS/4 }, 
{ {   0, 255, 255 }, USER_COLORS/4 }, 
{ {   0, 255,   0 }, USER_COLORS/4 }, 
{ { 255, 255,   0 }, USER_COLORS/4   }, 
{ { 255, 0,   0 }, -1 } };

s_color spectral_values[] =  /* really spectral */
{ { { 238, 138, 238 }, USER_COLORS/16   }, /* violet (V) */
  { { 25 ,  25, 112 }, 3*USER_COLORS/16 }, /* midnight blue (I) */
{ {   0,   0, 255 }, 3*USER_COLORS/16 },   /* blue  (B) */
{ {   0, 255,   0 }, 3*USER_COLORS/16 }, /* green (G) */
{ { 173, 252,   0 }, USER_COLORS/16 }, /*  green yellow (minus blue) (G-Y) */
{ { 255, 255,   0 }, 2*USER_COLORS/16   }, /* yellow (Y) */
{ { 255, 165,   0 }, 3*USER_COLORS/16 }, /* orange (O) */
{ { 255,   0,   0 }, -1 } }; /* red (R) */

s_color spectral_values2[] =  /* Ware's spectral -- NOT USED */
{ { { 255,   0, 255 }, USER_COLORS/5   }, /* violet (V) */
  { {   0,   0, 255 }, USER_COLORS/5 }, /* midnight blue (I) */
  { {   0, 255, 255 }, USER_COLORS/5 },   /* blue  (B) */
  { {   0, 255,   0 }, USER_COLORS/5 }, /* green (G) */
  { { 255, 255,   0 }, USER_COLORS/5 }, /* green (G) */
  { { 255,   0,   0 }, -1 } };

s_color gray_values[] =
{ { { 0, 0, 0 }, USER_COLORS }, /* black */
{ { 255, 255, 255}, -1 } }; /* white */

s_color blue_yellow_values[] = /* Robertson's Color Map */
{ { { 0,     0, 255 }, USER_COLORS/6 },
  { { 25,   25, 230 }, USER_COLORS/6 },
  { { 55,   55, 200 }, USER_COLORS/6 },
  { { 127, 127, 127 }, USER_COLORS/6 },
  { { 200, 200,  55 }, USER_COLORS/6 },
  { { 230, 230,  25 }, USER_COLORS/6 },
  { { 255, 255,   0}, -1 } };

/*
 * s_color pete_values[] =
 * { { { 255,  0,    0 }, USER_COLORS/2   },  //   red  
 *  { { 0,  255,    0 }, USER_COLORS/2 },    // green  
 *  { { 255, 255, 255 }, -1 } };             // white  
 */
s_color pete_values[] = /* actually Ware's experimental colormap */
                       /* but Pete told me about it */
{ { {   0,   0,    0 }, USER_COLORS/6 }, /* black */
  { {  25,  25,  112 }, USER_COLORS/8 }, /* dark blue */
  { { 148,   0,  140}, 5*USER_COLORS/24 }, /* dark purple */
  { { 170,   0,    0 }, USER_COLORS/4 }, /* dark red */
  { { 255, 165,    0 }, USER_COLORS/12 }, /* orange */
  { { 255, 255,    0 }, USER_COLORS/6 }, /* yellow */
  { { 255, 255,  255 }, -1 } }; /* white */

s_color hot_values[] =
{ { {   0,   0,    0 }, 3*USER_COLORS/8   },  /*  black  */
  { { 255,   0,    0 }, 3*USER_COLORS/8 },    /* red  */
  { { 255, 255,    0 }, 2*USER_COLORS/8 },    /* yellow */
  { { 255, 255, 255 }, -1 } };    /* white  */

s_color cool_values[] =
{ { {   0, 255,  255 }, USER_COLORS   },  /* cyan   */
  { { 255,   0,  255 }, -1 }};    /* purple  */

s_color copper_values[] =
{ { {   0,   0,    0 }, USER_COLORS   },  /*  black  */
  { { 255,  200,  128 }, -1 }};    /* copper  */

s_color sunrise_values[] = 
{ { {  25,  25,  112 }, USER_COLORS/4 }, /* midnight blue */
  { { 139, 102,  139 }, USER_COLORS/4 }, /* plum 4*/
  { { 238, 106,  167 },  USER_COLORS/4 }, /* pale violet red 1 */
  { { 255, 127,  0   }, USER_COLORS/4 }, /* dark orange 1 */
  { { 255, 220,  0   }, -1 }}; /* near gold */

s_color sunset_values[] = 
{ { { 255, 220,  0   }, USER_COLORS/4 }, /* near gold */
  { { 255, 127,  0   }, USER_COLORS/4 }, /* dark orange 1 */
  { { 238, 106,  167 }, USER_COLORS/4 }, /* pale violet red 1 */
  { { 139, 102,  139 }, USER_COLORS/4 }, /* plum 4*/
  { {  25,  25,  112 }, -1 }}; /* midnight blue */

s_color weather_values[] =  /* from the UIUC weather map */
{ { {   0, 143,    0 }, USER_COLORS/5 }, 
  { {   0, 207,    0 }, USER_COLORS/5 }, 
  { {  95, 251,   23 }, USER_COLORS/5 }, 
  { { 255, 252,   23 }, USER_COLORS/5 }, 
  { { 248, 122,   23 }, USER_COLORS/5 }, 
  { { 246,  34,   23 }, -1 }}; 

/* window counter into RCAS */
/* int zoomcount; */
/* the RCAS array -- core of it all... */
RCASParameters RCAS[MAXZOOM];
GC foregroundGC;

/* the input handler */
void (*CanvasInputHandler)(Event);

/* X stuff from xdraw... */

Display *canvas_display;
int canvas_depth;
Visual *canvas_visual;
Colormap Default_cmap;

/* zoom.xbm */
/* 48 x 48 */
char ZoOm_BiTs[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x00,
   0x00, 0xe0, 0xff, 0x00, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x07, 0x00, 0x00,
   0x00, 0xfe, 0xff, 0x0f, 0x00, 0x00, 0x00, 0xff, 0xf1, 0x1f, 0x00, 0x00,
   0x80, 0x1f, 0x00, 0x3f, 0x00, 0x00, 0xc0, 0x07, 0x00, 0x7c, 0x00, 0x00,
   0xe0, 0x03, 0x00, 0xf8, 0x00, 0x00, 0xf0, 0x01, 0x00, 0xf0, 0x01, 0x00,
   0xf0, 0x00, 0x00, 0xe0, 0x01, 0x00, 0xf0, 0x00, 0x00, 0xe0, 0x01, 0x00,
   0x78, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x78, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x78, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x7c, 0x00, 0x00, 0xc0, 0x07, 0x00,
   0x3c, 0x00, 0x00, 0x80, 0x07, 0x00, 0x3c, 0x00, 0x00, 0x80, 0x07, 0x00,
   0x3c, 0x00, 0x00, 0x80, 0x07, 0x00, 0x7c, 0x00, 0x00, 0xc0, 0x07, 0x00,
   0x78, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x78, 0x00, 0x00, 0xc0, 0x03, 0x00,
   0x78, 0x00, 0x00, 0xc0, 0x03, 0x00, 0xf0, 0x00, 0x00, 0xe0, 0x01, 0x00,
   0xf0, 0x00, 0x00, 0xe0, 0x01, 0x00, 0xf0, 0x01, 0x00, 0xf0, 0x01, 0x00,
   0xe0, 0x03, 0x00, 0xf8, 0x00, 0x00, 0xc0, 0x07, 0x00, 0xfc, 0x01, 0x00,
   0x80, 0x1f, 0x00, 0xff, 0x03, 0x00, 0x00, 0xff, 0xf1, 0xff, 0x07, 0x00,
   0x00, 0xfe, 0xff, 0xef, 0x0f, 0x00, 0x00, 0xfc, 0xff, 0xc7, 0x1f, 0x00,
   0x00, 0xe0, 0xff, 0x80, 0x3f, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x7f, 0x00,
   0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x01,
   0x00, 0x00, 0x00, 0x00, 0xf8, 0x03, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x07,
   0xf0, 0xc7, 0xc1, 0x11, 0xe4, 0x07, 0x00, 0x22, 0x22, 0x32, 0xc6, 0x03,
   0x00, 0x11, 0x14, 0x54, 0x85, 0x01, 0x80, 0x10, 0x14, 0x94, 0x04, 0x00,
   0x40, 0x10, 0x14, 0x14, 0x04, 0x00, 0x20, 0x20, 0x22, 0x12, 0x04, 0x00,
   0xf0, 0xc7, 0xc1, 0x11, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/* for the (unfinished) HB output routine */
char *HeaderFormats[MAX_HB_HEADER_LINES] = 
{ 
    "%-72s%-8s\n",                      /* line 1 */
    "%-14d%-14d%-14d%-14d%-14d\n",      /* line 2 */
    "%c%c%-12c%-14d%-14d%-14d%-14d\n",  /* line 3 */
    "%-16s%-16s%-20s%-20s\n",           /* line 4 */
    "%c%c%-12c%-14d%-14d\n"             /* line 5 */
};

/* print dialog data (shared between print_dialog and xhelpers.c) */
Widget print_dialog = NULL;
/* int print_creator = -1; */
