/*
 * mytime() provides a more or less portable timer function which returns
 *  time from some arbitrary and system-dependent initial time.  However,
 *    
 * t1 = mytime();
 * some_arbitrary_function();
 * t2 = mytime();
 * printf("some function took %e seconds of user+system time\n",t2-t1);
 *  
 * should be right....
 * 
 * This version is based on the getrusage() command.
 * Started 4/25/96 by tjl 
 */
#include <hb.h>

double mytime()
{
    struct rusage buff;
    int who = RUSAGE_SELF;
    double systime;
    double usertime;
    /* get the time */
    getrusage(who, &buff);
    /* calculate number of microseconds */
    systime = (double) buff.ru_stime.tv_sec + 1e-6 * buff.ru_stime.tv_usec;
    usertime = (double) buff.ru_utime.tv_sec + 1e-6 * buff.ru_utime.tv_usec;
    /* return the sum */
    return(systime + usertime);
}
