/* scale_strat.c: some example scaling strategies */
#include <hb.h>

int SClinear2(ScaleStrategyParameters *s) /* 1 norm with potential bitmap */
{
    int v = (int) ((s->val - s->min)/(s->max - s->min) * s->numcolors);
/*    if (!(s->bitmap))
	return(v);

    return((v > 0)?s->numcolors:0);
*/
    return((!(s->bitmap) * v) + ((s->bitmap) * (v>0) * s->numcolors));
}
int SCabslinear(ScaleStrategyParameters *s)    /* 1 norm of abs values */
{
    int v = (int) ((fabs(s->val) - s->absmin)/(s->absmax - s->absmin) * s->numcolors);

    return((!(s->bitmap) * v) + ((s->bitmap) * (v>0) * s->numcolors));
}
/* 
 * modified 7/5/94 to handle both ln and log_10 log scaling 
 * by tjl
 */

int SClog(ScaleStrategyParameters *s) /* scale logarithmically */
{
    
    double val,the_log;
    int v;
/*    if (s->val == 0.0)
 *	v = 0;
 *
 *   else
 *
 */
    val = ((s->val == 0.0) * MIN_SCALING_VALUE) + ((s->val != 0.0) * s->val);
    the_log = log(fabs(val));
    the_log = the_log * (((1-s->log10) * 1.0)  + (s->log10 * ONE_OVER_LN_10));
    v = (int) ((the_log - s->lmin)/(s->lmax - s->lmin) * s->numcolors);
    return((!(s->bitmap) * v) + ((s->bitmap) * (v>0) * s->numcolors));
}

/* THE FOLLOWING STRATEGIES ARE FOR REFERENCE ONLY -- THEY ARE NOT 
   SUPPORTED VIA MENUS!!  MakeMenus() and ScaleMenuCallback() will have
   to be changed to add these strategies (at least).  Also, none
   of them are in hbdraw.h...

   6/1/94 -- tjl
 */
int SClinear(ScaleStrategyParameters *s)    /* 1 norm */
{
    return( (int) ((s->val - s->min)/(s->max - s->min) * s->numcolors));
}
int SCpattern(ScaleStrategyParameters *s)    /* return one for a bitmap */
{
    if (fabs(s->val) > EPSILON)
	return(s->numcolors);
    return(0);
}
int SCsqrt(ScaleStrategyParameters *s)    /* 2 norm */
{
    double sqr = sqrt(s->val);
    double sqrmin = sqrt(fabs(s->min));
    double sqrmax = sqrt(fabs(s->max));
    
    return ((int) ((sqr-sqrmin)/(sqrmax - sqrmin) * s->numcolors));
}
