#include <hb.h>

/* globals for the point info dialog */
Pixmap p1;
Widget info_dialog;
Widget splash_dialog; /* 1/14/96 */
int created = 0;
extern Widget print_dialog;
/* end of the globals */

void
kill_dialog(Widget widget, XtPointer client_data, XtPointer call_data)
{
    XtUnmanageChild((Widget) client_data);
}
static void
kill_point_dialog(Widget widget, XtPointer client_data, XtPointer call_data)
{
    created = 0;
    /* printf("kill_point_dialog: created = %d\n",created);*/
    kill_dialog(0, client_data, 0);
}
void HBZoomHandler(Event e)
{
    int temp, dx, dy, sx, sy, bgidx;
    int NumRows, NumCols;
    static int startx = (-1), starty = (-1);
    static int endx, endy;
    int screen_height, screen_width, usable_height,usable_width;
    int input_startrow, input_startcol, input_endrow, input_endcol;
    ZoomParms z;
    char debugstr[100];
    int zc;

    /* set zoomcount from input */
    zc = e.zoomcount;
    /* try to find a contrasting color to back ground*/
    if (RCAS[zc].force_black == 0)
    {
	/* natural back ground, so max color is different if
	   colormap is good */
	bgidx = MAXIMUM_COLORS-1;
    }
    else
    {
	/* if the back ground is white, use black otherwise use white */
	bgidx = RCAS[zc].what_is_black;
	if (bgidx == WHITE_INDEX)
	    bgidx = RED_INDEX;
	else
	    bgidx = WHITE_INDEX;
    }
    XSetFunction(RCAS[zc].display, 
		 RCAS[zc].gcs[bgidx], GXxor );
    switch (e.type)
    {
    /* case ButtonPress:*/
    case BUTTON_PRESS:
	startx = endx = e.x;
	starty = endy = e.y;
	/* this is also necessary to make the rubber band thing work out */
	/* otherwise, you lose the corner of the rectangle AND get a spot
	   when the rubber band is drawn */
	XDrawPoint(RCAS[zc].display, RCAS[zc].window, 
		   RCAS[zc].gcs[bgidx], startx, starty);

	sprintf(debugstr,"Button Pressed: x, y = %d, %d\n",startx, starty);
	DEBUG1(debugstr);
	break;
    /* case ButtonRelease: */
    case BUTTON_RELEASE:
	dx = IDXRANGE(startx,endx);
	dy = IDXRANGE(starty,endy);
	sx = mymin( startx, endx );
	sy = mymin( starty, endy );

	/* clear out last xor'd rubber band rect. */
	XDrawRectangle(RCAS[zc].display, RCAS[zc].window,
		       RCAS[zc].gcs[bgidx], sx, sy, 
		       dx-1, dy-1);

	/* call click to reset input handler and icon */
	click((Widget) NULL,  (XEvent *)NULL, (String *) NULL, 0);

	/* set final end value */
	endx = e.x;
	endy = e.y;
	sprintf(debugstr,"Button Released: sx, sy = %d, %d, ex, ey = %d, %d\n",startx, starty, endx, endy);
	DEBUG1(debugstr);
	/* sort out start and end */
	if (endx < startx )
	{
	    SWAP(startx, endx, temp);
	}
	if (endy < starty )
	{
	    SWAP(starty, endy, temp);
	}
	input_startrow = RCAS[zc].input_startrow;
	input_endrow = RCAS[zc].input_endrow;
	input_startcol = RCAS[zc].input_startcol;
	input_endcol = RCAS[zc].input_endcol;
	screen_height = RCAS[zc].screen_height;
	screen_width = RCAS[zc].screen_width;
	NumRows = IDXRANGE(RCAS[zc].input_endrow,RCAS[zc].input_startrow);
	NumCols = IDXRANGE(RCAS[zc].input_endcol,RCAS[zc].input_startcol);
	/* get usable height and width just like compress did -- 4/9/94 */ 
	usable_height = screen_height;
	usable_width = screen_width;
	CalculateScreenSize( NumRows, NumCols, &usable_height, &usable_width,
			     RCAS[zc].conformal);
	/* use usable height and width instead of screen height/width 4/9/94*/ 
	/* ENFORCE_RANGE's added 4/19 */
	z.input_startrow=input_startrow+SCALE(starty,0,usable_height,NumRows);
	z.input_startrow= ENFORCE_RANGE(z.input_startrow, input_startrow, input_endrow);

	z.input_endrow= input_startrow+SCALE(endy,0,usable_height,NumRows);
	z.input_endrow= ENFORCE_RANGE(z.input_endrow, input_startrow, input_endrow);

	z.input_startcol= input_startcol + SCALE(startx,0,usable_width,NumCols);
	z.input_startcol = ENFORCE_RANGE(z.input_startcol, input_startcol, input_endcol);

	z.input_endcol = input_startcol+ SCALE(endx,0,usable_width,NumCols);
	z.input_endcol =  ENFORCE_RANGE(z.input_endcol, input_startcol, input_endcol);
	z.screen_width = ZOOM_CANVAS_WIDTH;
	z.screen_height = ZOOM_CANVAS_HEIGHT;
	/* zc is a pointer to the parent window */
	z.zoomcount = zc;
	sprintf(debugstr,"Button Released: mat: sx, sy = %d, %d, mat: ex, ey = %d, %d\n", z.input_startcol,z.input_startrow, z.input_endcol, z.input_endrow);
	DEBUG1(debugstr);
	zc = ZoomMat( &z );

	startx = starty  = (-1);
	break;
   /*  case MotionNotify:*/
    case MOUSE_MOVEMENT:
	if (startx >= 0) /* >= on 1/19/95 */
	{
	    dx = myabs( (endx-startx) );
	    dy = myabs( (endy-starty) );
	    sx = mymin( startx, endx );
	    sy = mymin( starty, endy );
	    
	    XDrawRectangle(RCAS[zc].display, RCAS[zc].window,
			   RCAS[zc].gcs[bgidx], sx, sy,
			   dx, dy);
	    dx = myabs( (e.x-startx) );
	    dy = myabs( (e.y-starty) );
	    sx = mymin( e.x, startx );
	    sy = mymin( e.y, starty );
	    XDrawRectangle(RCAS[zc].display, RCAS[zc].window,
			   RCAS[zc].gcs[bgidx], sx, sy,
			   dx, dy);
	    endx = e.x;
	    endy = e.y;
	}
    default:
	/* TBD */
	break;
    }
    /* restore white to copy mode */
    if (zc >= 0)
    {
	XSetFunction(RCAS[zc].display, 
		     RCAS[zc].gcs[bgidx], 
		     GXcopy );
    }
}
/*
 * 7/21/94 -- create an actual default handler (for dragging to update the 
 * info dialog) 
 * 
 * 
 */
void DefaultInputHandler(Event e)
{
    static int update_flag = 0;
    double matval;
    int compx, compy;
    int comp_index;
    ScaleStrategyParameters parms;
    int zc, x,y;
    static int oldx = -1, oldy = -1;
    int matx, maty, usablex, usabley, NumRows, NumCols, color;
    /* get the zoomcount */
    zc = e.zoomcount;

    /* update the update flag */
    if (e.type == BUTTON_PRESS)
    {
	update_flag = 1;
    }
    else if (e.type == BUTTON_RELEASE)
    {
	update_flag = 0;
    }

    /* update the info dialog if need be */
    if (update_flag == 1)
    {
	x = e.x;
	y = e.y;
	/* stolen from input */
	usablex = RCAS[zc].screen_width;
	usabley = RCAS[zc].screen_height;
	
	/* calc. number of rows and cols */
	NumCols = IDXRANGE(RCAS[zc].input_endcol,RCAS[zc].input_startcol);
	NumRows = IDXRANGE(RCAS[zc].input_endrow,RCAS[zc].input_startrow);
	
	/* calc screen size */
	CalculateScreenSize(NumRows, NumCols, &usabley, &usablex, 
			    RCAS[zc].conformal);
	
	/* figure out matrix position of current point */
	matx = RCAS[zc].input_startcol + 
	    (int) (((double)x/(double)usablex) *NumCols);
	maty = RCAS[zc].input_startrow + 
	    (int) (((double)y/(double) usabley) * NumRows);

	/* check for out of range values */
	if (matx > RCAS[zc].input_endcol)
	    matx = RCAS[zc].input_endcol;
	else if (matx < RCAS[zc].input_startcol)
	    matx = RCAS[zc].input_startcol;
	
	if (maty > RCAS[zc].input_endrow)
	    maty = RCAS[zc].input_endrow;
	else if (maty < RCAS[zc].input_startrow)
	    maty = RCAS[zc].input_startrow;

	/* only continue on if on a new mat value */
	if ((oldx != matx) || (oldy != maty))
	{
	    matval = GetMatrixValue(zc, maty, matx);
	    /* calculate reverse mapping from matx/y -> x/y */
	    /* base it on center of "clicked on" pixel */
	    compx = (int) ( (double) ((matx-RCAS[zc].input_startcol) + 0.5)/
			    (double) NumCols * (double) usablex);
	    compy = (int) ( (double) ((maty-RCAS[zc].input_startrow) + 0.5)/
			    (double) NumRows * (double) usabley);

	    /* paranoia checking */
	    if (compx < 0)
		compx = 0;
	    if (compy < 0)
		compy = 0;
	    /* calculate index into compression mat */
	    comp_index =  compy * RCAS[zc].comp->NumCols + compx;
	    parms.val = RCAS[zc].comp->data.d1[comp_index];
/*
 * fprintf(stderr,"matx=%d, maty=%d, value=%f, matval=%f, x = %d, y = %d,usex = %d, usey = %d\n",
 *	  matx, maty, parms.val,matval,compx,compy,usablex, usabley);
 */
	    /* duplicate of scale code  -- set up the ScaleStrat parms */
	    parms.max = RCAS[zc].max;
	    parms.min = RCAS[zc].min;
	    parms.absmax = RCAS[zc].absmax;
	    parms.absmin = RCAS[zc].absmin;
	    parms.log10 = RCAS[zc].log10;
	    
	    /* log of min value */
	    /* the == is right -- only if it's 0 */
	    if (parms.absmin == 0.0)
		parms.lmin = -300*log(10); /* say it's 10**-300 */
	    else
		parms.lmin = log(parms.absmin);
	    
	    /* log of max value */
	    if (parms.absmax == 0.0)
		parms.lmax = -300*log(10); /* say it's 10**-300 */
	    else
		parms.lmax = log(parms.absmax);
	    
	    /* check for log base 10 scaling */
	    if (parms.log10 != 0)
	    {
		parms.log10 = 1;
		parms.lmin = parms.lmin * ONE_OVER_LN_10;
		parms.lmax = parms.lmax * ONE_OVER_LN_10;
	    }
	    /* reset absmin after calculating logs */
	    if (RCAS[zc].zero_in_input)
		parms.absmin = 0.0;
	    else
		parms.absmin = RCAS[zc].absmin;
	    parms.bitmap = RCAS[zc].bitmap;
	    parms.numcolors = RCAS[zc].numcolors;
	    
	    /* color = RCAS[zc].sstrat(&parms) + RCAS[zc].startcolor; */
	    if ((fabs(parms.val) < SCALE_EPSILON) && (RCAS[zc].force_black))
		color = RCAS[zc].what_is_black;
	    else
	    {
		color = RCAS[zc].sstrat(&parms);
		color += RCAS[zc].startcolor;
	    }
	    /* 7/5 -- put in log value for log scaling */
	    if (RCAS[zc].sstrat == SClog) 
	    {
		if (parms.val == 0.0)
		    parms.val = -300*log(10); /* say it's 10**-300 */
		else
		    parms.val = log(fabs(parms.val));
		if (RCAS[zc].log10 != 0)
		{
		    parms.val *= ONE_OVER_LN_10;
		}
	    }
	    /* pop up dialog if button pressed */
	    PointInfo(zc, matx, maty, parms.val, matval, color);
	} /* end of if a new mat value */
    } /* end of if update_flag */
    /* update old values */
    oldx = matx; oldy = maty; 
} /* end of DefaultInputHandler */

/* this is the function passed to InitIcon, which will be called later */
void HBZoomHookup(int flag)
{
    char debugstr[100];
    sprintf(debugstr,"HBZoomHookup entered: flag = %d\n",flag);
    TRACE(debugstr);
    if (flag)
	CanvasInputHandler = HBZoomHandler;
    else
	CanvasInputHandler = DefaultInputHandler;
    TRACE("HBZoomHookup done\n");
}

/*
 * This sets up the globals when the window changes, given that the widgets
 * are already set up...
 *
 */
void SetXGlobals(int zc)
{
    Widget CanvasWidget;
    char debugstr[100];

    sprintf(debugstr,"SetXGlobals entered: zc = %d\n",zc);
    TRACE(debugstr);
    CanvasWidget = RCAS[zc].wids.canvas;
    canvas_display = XtDisplay( CanvasWidget );
    XtVaGetValues(CanvasWidget,
		  XmNdepth, &canvas_depth,
		  XmNvisual, &canvas_visual,
		  NULL);
    /* zoomcount = zc; // hmm */
    /* ColorBarWidget = RCAS[zc].wids.color_bar; */
    /* ColorBarPixmap = RCAS[zc].wids.color_pix; */
    /* ColorMinWidget = RCAS[zc].wids.color_min; */
    /* ColorMaxWidget = RCAS[zc].wids.color_max; */
    /* CursorPosWidget = RCAS[zc].wids.cur_pos; */
    /* msgLabel = RCAS[zc].wids.msg_label; */
    /* canvas_screen = XtScreen( CanvasWidget ); */
    /* canvas_window = XtWindow( CanvasWidget ); */
    /* toplevel = RCAS[zc].wids.toplevel; */
    /* fprintf(stderr,"SetXGlobals: toplevel = %d\n",toplevel); */
    TRACE("SetXGlobals done\n");
} 

int InWidStruct(Widget w, WidStruct *wids)
{
    int t;

    return((w == wids->toplevel)  || (w == wids->form)      ||
	   (w == wids->menu)      || (w == wids->row_col)   ||
	   (w == wids->canvas)    || (w == wids->frame)     ||
	   (w == wids->msg_win)   || (w == wids->cur_pos)   ||
	   (w == wids->color_min) || (w == wids->color_max) ||
	   (w == wids->color_bar) || (w == wids->msg_label) ||
	   (w == wids->icons));
}
    
int GetZoomcount(Widget w)
{
    int rc = -1;
    char debugstr[100];
    int i;

    for (i = 0; i < MAXZOOM; i++)
    {
	if (InWidStruct(w,&RCAS[i].wids))
	{
	    rc = i;
	    break;
	}
    }
    return(rc);
    
}

/* 
 * from O'Reilly Vol 6
 */

/*
 * Widget
 * GetTopShell(Widget w)
 * {
 *    while (w && !XtIsWMShell(w))
 *	w = XtParent(w);
 *   return w;
 * }
 */

/*
 * CloseZoomWindow closes the zoom window associated with RCAS[zc]
 * by unmanaging its toplevel widget which returns it to the void,
 * and deallocating its associated RCAS structure.
 *
 * written 4/14/94 by tjl
 */
void CloseZoomWindow(int zc)
{
    char debugmsg[100];
    sprintf(debugmsg,"CloseZoomWindow: NUKING %d!!!!\n",zc);
    DEBUG1(debugmsg);
    /* XtUnmanageChild(RCAS[zc].wids.toplevel); // only for dialogs */
    /* dealloc 3/31 */

    /* remove data as necessary */
    DeallocRCAS( RCAS, zc, RCAS_NO_NUKES);
    /* and unrealize the widget */
    XtUnrealizeWidget(RCAS[zc].wids.toplevel);
}

/*
 * CloseAllZoomWindows() loops thru all RCAS's after 0 and, if any are 
 * allocated, uses CloseZoomWindow() to take care of them.
 *
 * written 4/14/94 by tjl
 */
void CloseAllZoomWindows()
{
    int i;
    /* loop through all RCASs */
    for (i = 1; i < MAXZOOM; i++)
    {
	/* if it's in use, destroy it */
	if (RCAS[i].used)
	    CloseZoomWindow(i);
    }
    /* close the info dialog  -- 6/7/94 */
    if (info_dialog != NULL)
    {
	created = 0;
	/* printf("info_dialog not NULL: created = %d\n",created); */
	XtUnmanageChild(info_dialog);
    }
    /* close the print dialog -- 1/13/95 */
    if (print_dialog != NULL)
    {
	XtUnmanageChild(print_dialog);
    }
    /* close the splash dialog -- 1/14/96 */
    if (splash_dialog != NULL)
    {
	XtUnmanageChild(splash_dialog);
    }
}

/*
 * 4/19/94 -- tjl 
 */
void XErrorMsg(char *s)
{
    int zc = 0; /* hmmm */
    static Widget dialog; /* static for reuse */
    XmString xms;
    Widget motif_screen;

    char debugstr[200];

    sprintf(debugstr,"XErrorMsg entered: s = %s\n",s);
    TRACE(debugstr);

    XUndefineCursor(RCAS[0].display, RCAS[0].window);
    /* if no window, just use stderr */
    if (RCAS[zc].mapped == 0)
    {
	fprintf(stderr,"%s\n",s);
    }
    /* if we don't have a dialog, create one */
    if (!dialog)
    {
	dialog = XmCreateErrorDialog(RCAS[zc].wids.toplevel, "error", NULL, 0);

	/* set all callbacks to kiss the sky */
	XtAddCallback(dialog, XmNokCallback, kts_cb, NULL);
	XtAddCallback(dialog, XmNhelpCallback, kts_cb, NULL);
	XtAddCallback(dialog, XmNcancelCallback, kts_cb, NULL); 
    }
    
    /* set the error message */
    xms = XmStringCreateSimple(s);
    XtVaSetValues(dialog, XmNmessageString, xms, NULL);
    XmStringFree(xms);
    /* and popup the error dialog */
    XtManageChild(dialog);
    XtPopup(XtParent(dialog), XtGrabNone);
}

/* 
 * SetCursor: 
 * This function sets the cursor to the predefined cursors (whose cursor
 * number is shape: see /usr/lib/X11/cursorfont.h for a listing) in
 * the window for RCAS *rcas. 
 * 
 */
void SetCursor(int shape, Cursor *cursor)
{
    int i;

    /* create the cursor */
    *cursor = XCreateFontCursor(RCAS[0].display, shape);
   
    /* set the cursor for all the windows that are mapped */ 
    for (i = 0; i < MAXZOOM; i++)
    {
	if (RCAS[i].mapped)
	{
	    XDefineCursor(RCAS[i].display, XtWindow(RCAS[i].wids.toplevel), *cursor);
	}
    }
}

/* 
 * ResetCursor: 
 * This function resets the cursor using XUndefineCursor() for all windows,
 * and frees the input cursor.
 * 
 * 
 */
void ResetCursor(Cursor cursor)
{
    int i;
    
    /* reset the cursor for all the windows that are mapped */ 
    for (i = 0; i < MAXZOOM; i++)
    {
	if (RCAS[i].mapped)
	{
	    XUndefineCursor(RCAS[i].display, XtWindow(RCAS[i].wids.toplevel));
	}
    }
    /* free the cursor */
    XFreeCursor(RCAS[0].display, cursor);
}

double GetMatrixValue(int zc, int irow, int icol)
{
    DaMatrix *D = RCAS[zc].input;
    HBMatrix *hb;
    DenseMatrix *d;
    int sp_col_major = 0;
    int index_offset;
    /* sp_col_major should be = RCAS[zc].sp_col_major for completeness, but
       it's hardcoded in rcas.c, so it's hardcoded here, too */
    int row, col, minrowidx, maxrowidx, mincolidx, maxcolidx, offset;

    if (D->type == HB)
    {
	if (D->hb_col_inds[0] == 0)
	    index_offset = 0;
	else
	    index_offset = 1;

	hb = D->data.hb;
	/* check to see if accessing data in column major form */
	if (!sp_col_major) 
	 {
	    /* check for out of range input */
	    if ((irow < 0) || (irow >= hb->head.NumRows) || 
		(icol < 0) || (icol >= hb->head.NumCols))
	    {
		/* makes as much sense as anything else... */
		return(0.0);
	    }
	    /* get min/max row indices */
	    minrowidx = hb->col_inds[icol] - index_offset;
	    maxrowidx = hb->col_inds[icol+1] - index_offset;
	    for (row = minrowidx; row < maxrowidx; row++)
	    {
		if ((hb->row_inds[row]-index_offset) == irow)
		{
		    return(hb->values[row]);
		}
	    }
	    /* if here, didn't find the value, so must be a zero entry */
	    return(0.0); 
	} 
	else /* not col major  --- untested code */
	{
	    /* check for out of range input */
	    if ((irow < 0) || (irow >= hb->head.NumCols) || 
		(icol < 0) || (icol >= hb->head.NumRows))
	    {
	 	return(0.0);
	    }
	    mincolidx = hb->col_inds[irow]-index_offset;
	    maxcolidx = hb->col_inds[irow+1] -index_offset;
	    for (col = mincolidx; col < maxcolidx; col++)
	    {
	 	if ((hb->row_inds[col]-index_offset) == icol)
	 	{
	 	    return(hb->values[col]);
	 	}
	    }
	    return(0.0); 
	}
    } /* end of if working with an HB matrix */
    else  /* working with a dense matrix */
    {
	d = D->data.d;
	if (d->row_major)
	{
	    row = irow;
	    col = icol;
	    offset = d->NumCols;
	}
	else /* not row major */
	{
	    row = icol;
	    col = irow;
	    offset = d->NumRows;
	}

	/* if out of range, return 0 */
	if ((irow < 0) || (irow > d->NumRows) || 
	    (icol < 0) || (icol > d->NumCols))
	{
	    return(0.0);
	}
	if (d->one_d)
	    return(d->data.d1[row * offset + col]);
	return(d->data.d2[row][col]);
    }
}


/*
 * modified 1/13/95 to add zc as a parm -- see if it fixes Randy's popup
 *  problem
 */
void PointInfo(int zc,int col, int row, double value, double matval, int color)
{
    /* int zc = 0; // 1/13/95 */
    int pix_width = 50;
    int pix_height = 50;
    static Widget pix_label, text_label, form;
    int print_color;
    Widget pane, form2, dismiss; 
    Dimension h;
    int actcol;
    XmString xms;
    char s[500];
    int ocreated;

    /* if we don't have a dialog, create one */

    /* this is modified from O'Reilly's old Vol. 6 on Motif
     *  pp. 204-205 
     */
    
    ocreated = created; /* 12/1/95 */
    if (!created)
    {
        /* printf("XFreePixmap: created = %d\n",created); */
	created = 1;
    }
    else
    {
	/* 1/13/95 */
	/* XFreePixmap(RCAS[0].display, p1); */
      /* printf("XFreePixmap created = %d\n",created);*/
	XFreePixmap(RCAS[zc].display, p1); 
    }
    p1 = XCreatePixmap(RCAS[zc].display,
		       /* replaced with window on 12/1/95
		        *	      RootWindow(RCAS[zc].display, 
			*	 DefaultScreen(RCAS[zc].display)),
			*/
		       RCAS[zc].window,
		      pix_width, pix_height, canvas_depth);

    print_color = (color - RCAS[zc].startcolor) + 1;
    if (print_color < 0)
	print_color = 0;

    /*
     * if ((RCAS[zc].force_black) && (color == RCAS[zc].what_is_black))
     * {
     *   print_color = 0;
     * }
     * else
     * {
     *   print_color = color - RCAS[zc].startcolor+1;
     *}
     */

    /* create a dialog shell */
    if ((info_dialog) && (ocreated == 0))
    {
      /* printf("info_dialog: created = %d\n",ocreated); */
	info_dialog = 0;
    }
    if (!info_dialog)
    {
	info_dialog = XtVaCreatePopupShell("Point Info",
				  xmDialogShellWidgetClass, 
				  RCAS[zc].wids.toplevel,
				  NULL);
	/* create a paned window for the main window manager */
	pane = XtVaCreateWidget("pane", xmPanedWindowWidgetClass,
			    info_dialog, XmNsashWidth, 1, 
			    XmNsashHeight, 1,
			    NULL);
	/* now create a form widget for the pixmap and the text */
	form = XtVaCreateWidget("form", xmFormWidgetClass,
			    pane,
			    NULL);
    
    
	/* create a label for the pixmap */
	pix_label = XtVaCreateManagedWidget("pix_label", xmLabelGadgetClass,
					    form, 
					    XmNlabelType, XmPIXMAP,
					    XmNlabelPixmap, p1,
					    XmNleftAttachment, XmATTACH_FORM,
					    XmNleftOffset, 2,
					    XmNrightAttachment, XmATTACH_NONE,
					    XmNtopAttachment, XmATTACH_FORM,
					    XmNbottomAttachment, XmATTACH_FORM,
					    NULL);

	/* create another label for the text */
	
	sprintf(s,"At (%6d, %6d):\nInput Value = %16.4e\nScaled Value = %16.4e\nColor = %4d out of %4d\n",
		row+STARTING_OUT_MAT_ADDR,col+STARTING_OUT_MAT_ADDR,
		matval, value,print_color,USER_COLORS);
	xms = XmStringCreateLtoR(s, XmSTRING_DEFAULT_CHARSET);
	text_label = XtVaCreateManagedWidget("text_label",xmLabelGadgetClass,
					     form,
					     XmNlabelString, xms,
					     XmNleftAttachment, XmATTACH_WIDGET,
					     XmNleftWidget, pix_label,
					     XmNrightAttachment, XmATTACH_FORM,
					     XmNrightOffset, 2,
					     XmNtopAttachment, XmATTACH_FORM,
					     XmNbottomAttachment, XmATTACH_FORM,
					     NULL);

	XtManageChild(form);
    
	/* action area form */
	/* separate it up into 3 sections:
	 *   <empty>   DISMISS   <empty>  
	 *  0       1          2        3
	 *  Fraction Base controls number of sections,
	 *  Attachment positions control where the button goes.
	 */
	
	form2 = XtVaCreateWidget("form2", xmFormWidgetClass, pane,
				 XmNfractionBase, 3,
				 NULL);
	/* hookup the one button */
	dismiss = XtVaCreateManagedWidget("Dismiss",
					  xmPushButtonGadgetClass, form2,
					  XmNtopAttachment, XmATTACH_FORM,
					  XmNbottomAttachment, XmATTACH_FORM,
					  XmNleftAttachment, XmATTACH_POSITION,
					  XmNleftPosition, 1,
					  XmNrightAttachment, XmATTACH_POSITION,
					  XmNrightPosition, 2,
					  XmNshowAsDefault, True,
					  XmNdefaultButtonShadowThickness,1,
					  NULL);
	/* destroy the widget if pressed */
	XtAddCallback(dismiss, XmNactivateCallback, 
		      kill_point_dialog, info_dialog);
    
	/* manage the action area */
	XtManageChild(form2);
	/* don't allow resizing of the button area */
	XtVaGetValues(dismiss, XmNheight, &h, NULL);
	XtVaSetValues(form2, XmNpaneMaximum, h, XmNpaneMinimum, h, NULL);
	XtManageChild(pane);
    }
    else /* just reset the text */
    {
	sprintf(s,"At (%6d, %6d):\nInput Value = %16.4e\nScaled Value = %16.4e\nColor = %4d out of %4d\n",
		row+STARTING_OUT_MAT_ADDR,col+STARTING_OUT_MAT_ADDR,
		matval, value,print_color,USER_COLORS);
	xms = XmStringCreateLtoR(s, XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues(text_label, XmNlabelString, xms, NULL);
    }
    XmStringFree(xms);

    /* DEBUGGING */
    /* fprintf(stderr,"%s",s); */
    /* fill the  pixmap */
    XFillRectangle(RCAS[zc].display, p1, RCAS[zc].gcs[color],
		   0,0,pix_width, pix_height);

    XtVaSetValues(pix_label, XmNlabelPixmap, p1, NULL);
    /* make our pixmap the symbol pixmap and write our string */

    /* and popup the dialog */
    XtManageChild(info_dialog);
    XtPopup(info_dialog, XtGrabNone);
    /* XFreePixmap(RCAS[zc].display,p); */
}

/*
 * 8/10/96 -- slightly modified from FindDeepestVisual() in R&J, p. 433
 *         FindDecentVisual() finds a visual with at least *depth planes
 *         of color and of visual class vis_class.  If no visual available,
 *         *cmap_size is set to -1.
 */
void FindDecentVisual( Display *d, int screen, int vis_class, int *cmap_size,
		       Visual **v)
{
    int req_cmap_size;
    XVisualInfo vinfo_template;
    XVisualInfo *vis_array;
    int i, nvis;
    int max_cmap_size, max_cmap_idx;
   
    /* init */
    req_cmap_size = *cmap_size;
    *cmap_size = -1; /* assume failure */

    /* query init */
    vinfo_template.screen = screen;
    /* init visual class name */
#if defined(__cplusplus) || defined(c_plusplus)
    vinfo_template.c_class = vis_class;
#else /* C */
    vinfo_template.class = vis_class;
#endif

    /* get the visuals */
    vis_array = XGetVisualInfo( d, VisualClassMask | VisualScreenMask,
				&vinfo_template, &nvis);

    /* if one is not available, bail */
    if ((vis_array == (XVisualInfo *) NULL) || (nvis < 1))
    {
	*v = (Visual *) NULL;
	return;
    }

    /* for each visual */
    max_cmap_idx = 0;
    max_cmap_size = vis_array[0].colormap_size;
    for (i = 0; i < nvis; i++)
    {
	if (vis_array[i].colormap_size > max_cmap_size)
	{
	    max_cmap_idx = i;
	    max_cmap_size = vis_array[i].colormap_size;
	}
    }
    if (max_cmap_size < req_cmap_size) 
    {
	*v = (Visual *) NULL;
    }
    else
    {
	*cmap_size = vis_array[max_cmap_idx].depth;
	*v = vis_array[max_cmap_idx].visual;
    }
    /*
     * printf("found it: idx = %d, cmap_size = %d, v = %x\n",
     *	   max_cmap_idx,*cmap_size, *v);
     */
    /* free the vis array */
    XFree((void *) vis_array);
}
